<template>
  <div id="app">
    <header class="header container">
      <nav>
        <router-link to="/">Афиша</router-link> |
        <template v-if="!this.$store.state.isAuthenticated">
          <router-link to="/register">Зарегистрироваться</router-link> |
          <router-link to="/login">Войти</router-link>
        </template>
        <template v-else>
          <router-link to="/tickets">Купленные билеты</router-link> |
          <a class="logout" @click="logout">Выйти</a>
        </template>
      </nav>
    </header>
    <router-view/>
  </div>
</template>

<script>
import axios from "axios"


export default {
  name: 'App',
  beforeCreate() {
    this.$store.commit('initializeStore')

    const token = this.$store.state.token

    axios.defaults.headers.common['Authorization'] = token ? `Bearer ${token}` : ''
  },
  methods: {
    logout() {
      axios
          .post('auth/logout/')
          .then(() => {
            this.$store.commit('removeToken')
            axios.defaults.headers.common['Authorization'] = ''
            localStorage.removeItem('token')
            this.$router.push('/login')
          })
          .catch(err => err)
    }
  }
}
</script>

<style lang="scss">
$accentColor: #42b983;

.logout {
  cursor: pointer;
}

#app {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
}

nav {
  padding: 30px;

  a {
    font-weight: bold;
    color: #2c3e50;
    text-decoration: none;

    &:hover {
      color: #2c3e50;
    }

    &.router-link-exact-active {
      color: $accentColor;
    }
  }
}
</style>
